diff --git a/lib/conntrack.c b/lib/conntrack.c
index 2f9b17670..2392a2ea4 100644
--- a/lib/conntrack.c
+++ b/lib/conntrack.c
@@ -2089,12 +2089,12 @@ conn_key_extract(struct conntrack *ct, struct dp_packet *pkt, ovs_be16 dl_type,
     ctx->key.dl_type = dl_type;
 
     if (ctx->key.dl_type == htons(ETH_TYPE_IP)) {
-        bool hwol_bad_l3_csum = dp_packet_ip_csum_bad(pkt);
+        bool hwol_bad_l3_csum = dp_packet_ol_ip_csum_bad(pkt);
         if (hwol_bad_l3_csum) {
             ok = false;
             COVERAGE_INC(conntrack_l3csum_err);
         } else {
-            bool hwol_good_l3_csum = dp_packet_ip_csum_good(pkt)
+            bool hwol_good_l3_csum = dp_packet_ol_ip_csum_good(pkt)
                                      || dp_packet_ol_tx_ipv4(pkt);
             /* Validate the checksum only when hwol is not supported. */
             ok = extract_l3_ipv4(&ctx->key, l3, dp_packet_l3_size(pkt), NULL,
@@ -2107,9 +2107,9 @@ conn_key_extract(struct conntrack *ct, struct dp_packet *pkt, ovs_be16 dl_type,
     }
 
     if (ok) {
-        bool hwol_bad_l4_csum = dp_packet_l4_csum_bad(pkt);
+        bool hwol_bad_l4_csum = dp_packet_ol_l4_csum_bad(pkt);
         if (!hwol_bad_l4_csum) {
-            bool  hwol_good_l4_csum = dp_packet_l4_csum_good(pkt)
+            bool  hwol_good_l4_csum = dp_packet_ol_l4_csum_good(pkt)
                                       || dp_packet_ol_tx_l4_csum(pkt);
             /* Validate the checksum only when hwol is not supported. */
             if (extract_l4(&ctx->key, l4, dp_packet_l4_size(pkt),
diff --git a/lib/dp-packet.c b/lib/dp-packet.c
index b4ee8c33c..a4ca5a052 100644
--- a/lib/dp-packet.c
+++ b/lib/dp-packet.c
@@ -32,7 +32,7 @@ dp_packet_init__(struct dp_packet *p, size_t allocated, enum dp_packet_source so
     dp_packet_reset_offsets(p);
     pkt_metadata_init(&p->md, 0);
     dp_packet_reset_cutlen(p);
-    dp_packet_reset_offload(p);
+    dp_packet_ol_reset(p);
     /* Initialize implementation-specific fields of dp_packet. */
     dp_packet_init_specific(p);
     /* By default assume the packet type to be Ethernet. */
diff --git a/lib/dp-packet.h b/lib/dp-packet.h
index acb236a7d..ac160985d 100644
--- a/lib/dp-packet.h
+++ b/lib/dp-packet.h
@@ -933,7 +933,7 @@ dp_packet_rss_valid(const struct dp_packet *p)
 }
 
 static inline void
-dp_packet_reset_offload(struct dp_packet *p)
+dp_packet_ol_reset(struct dp_packet *p)
 {
     *dp_packet_ol_flags_ptr(p) &= ~DP_PACKET_OL_SUPPORTED_MASK;
 }
@@ -1049,28 +1049,28 @@ dp_packet_ol_set_tcp_seg(struct dp_packet *p)
 }
 
 static inline bool
-dp_packet_ip_csum_good(const struct dp_packet *p)
+dp_packet_ol_ip_csum_good(const struct dp_packet *p)
 {
     return (*dp_packet_ol_flags_ptr(p) & DP_PACKET_OL_RX_IP_CSUM_MASK) ==
             DP_PACKET_OL_RX_IP_CSUM_GOOD;
 }
 
 static inline bool
-dp_packet_ip_csum_bad(const struct dp_packet *p)
+dp_packet_ol_ip_csum_bad(const struct dp_packet *p)
 {
     return (*dp_packet_ol_flags_ptr(p) & DP_PACKET_OL_RX_IP_CSUM_MASK) ==
             DP_PACKET_OL_RX_IP_CSUM_BAD;
 }
 
 static inline bool
-dp_packet_l4_csum_good(const struct dp_packet *p)
+dp_packet_ol_l4_csum_good(const struct dp_packet *p)
 {
     return (*dp_packet_ol_flags_ptr(p) & DP_PACKET_OL_RX_L4_CSUM_MASK) ==
             DP_PACKET_OL_RX_L4_CSUM_GOOD;
 }
 
 static inline bool
-dp_packet_l4_csum_bad(const struct dp_packet *p)
+dp_packet_ol_l4_csum_bad(const struct dp_packet *p)
 {
     return (*dp_packet_ol_flags_ptr(p) & DP_PACKET_OL_RX_L4_CSUM_MASK) ==
             DP_PACKET_OL_RX_L4_CSUM_BAD;
diff --git a/lib/ipf.c b/lib/ipf.c
index fd40e32c4..e78559491 100644
--- a/lib/ipf.c
+++ b/lib/ipf.c
@@ -574,7 +574,7 @@ ipf_list_state_transition(struct ipf *ipf, struct ipf_list *ipf_list,
 static bool
 ipf_is_valid_v4_frag(struct ipf *ipf, struct dp_packet *pkt)
 {
-    if (OVS_UNLIKELY(dp_packet_ip_csum_bad(pkt))) {
+    if (OVS_UNLIKELY(dp_packet_ol_ip_csum_bad(pkt))) {
         COVERAGE_INC(ipf_l3csum_err);
         goto invalid_pkt;
     }
@@ -608,7 +608,7 @@ ipf_is_valid_v4_frag(struct ipf *ipf, struct dp_packet *pkt)
         goto invalid_pkt;
     }
 
-    if (OVS_UNLIKELY(!dp_packet_ip_csum_good(pkt)
+    if (OVS_UNLIKELY(!dp_packet_ol_ip_csum_good(pkt)
                      && !dp_packet_ol_tx_ipv4(pkt)
                      && csum(l3, ip_hdr_len) != 0)) {
         COVERAGE_INC(ipf_l3csum_err);
diff --git a/lib/netdev-native-tnl.c b/lib/netdev-native-tnl.c
index 40705e190..48f13b4bd 100644
--- a/lib/netdev-native-tnl.c
+++ b/lib/netdev-native-tnl.c
@@ -88,7 +88,7 @@ netdev_tnl_ip_extract_tnl_md(struct dp_packet *packet, struct flow_tnl *tnl,
 
         ovs_be32 ip_src, ip_dst;
 
-        if (OVS_UNLIKELY(!dp_packet_ip_csum_good(packet))) {
+        if (OVS_UNLIKELY(!dp_packet_ol_ip_csum_good(packet))) {
             if (csum(ip, IP_IHL(ip->ip_ihl_ver) * 4)) {
                 VLOG_WARN_RL(&err_rl, "ip packet has invalid checksum");
                 return NULL;
@@ -190,7 +190,7 @@ udp_extract_tnl_md(struct dp_packet *packet, struct flow_tnl *tnl,
     }
 
     if (udp->udp_csum) {
-        if (OVS_UNLIKELY(!dp_packet_l4_csum_good(packet))) {
+        if (OVS_UNLIKELY(!dp_packet_ol_l4_csum_good(packet))) {
             uint32_t csum;
             if (netdev_tnl_is_header_ipv6(dp_packet_data(packet))) {
                 csum = packet_csum_pseudoheader6(dp_packet_l3(packet));
diff --git a/lib/netdev.c b/lib/netdev.c
index 08f2e4b87..9043d5aaf 100644
--- a/lib/netdev.c
+++ b/lib/netdev.c
@@ -913,7 +913,7 @@ netdev_pop_header(struct netdev *netdev, struct dp_packet_batch *batch)
             /* Reset the offload flags if present, to avoid wrong
              * interpretation in the further packet processing when
              * recirculated.*/
-            dp_packet_reset_offload(packet);
+            dp_packet_ol_reset(packet);
             pkt_metadata_init_conn(&packet->md);
             dp_packet_batch_refill(batch, packet, i);
         }
diff --git a/lib/packets.c b/lib/packets.c
index 4a7643c5d..8f0bd6811 100644
--- a/lib/packets.c
+++ b/lib/packets.c
@@ -439,7 +439,7 @@ pop_mpls(struct dp_packet *packet, ovs_be16 ethtype)
 
         /* Invalidate offload flags as they are not valid after
          * decapsulation of MPLS header. */
-        dp_packet_reset_offload(packet);
+        dp_packet_ol_reset(packet);
     }
 }
 